--Custom Signpost Frame

rawset(_G, "sp_participationtrophy" , CV_RegisterVar({
	name = "sp_participationtrophy",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

local signpodium = {
	SKINCOLOR_MUSTARD,
	SKINCOLOR_SILVER,
	SKINCOLOR_CINNAMON
}

local superpodium = {
	[1] = 	{SKINCOLOR_SUPER1,
			SKINCOLOR_SUPER2,
			SKINCOLOR_SUPER3,
			SKINCOLOR_SUPER4,
			SKINCOLOR_SUPER5},

	[2] = 	{SKINCOLOR_WSUPER1,
			SKINCOLOR_WSUPER2,
			SKINCOLOR_WSUPER3,
			SKINCOLOR_WSUPER4,
			SKINCOLOR_WSUPER5},

	[3] = 	{SKINCOLOR_TSUPER1,
			SKINCOLOR_TSUPER2,
			SKINCOLOR_TSUPER3,
			SKINCOLOR_TSUPER4,
			SKINCOLOR_TSUPER5},

	[4] = 	{SKINCOLOR_KSUPER1,
			SKINCOLOR_KSUPER2,
			SKINCOLOR_KSUPER3,
			SKINCOLOR_KSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_TSUPER1,
			SKINCOLOR_TSUPER2,
			SKINCOLOR_TSUPER3,
			SKINCOLOR_TSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_SUPER1,
			SKINCOLOR_SUPER2,
			SKINCOLOR_SUPER3,
			SKINCOLOR_SUPER4,
			SKINCOLOR_WUPER5,
			SKINCOLOR_GSUPER1,
			SKINCOLOR_GSUPER2,
			SKINCOLOR_GSUPER3,
			SKINCOLOR_GSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_ASUPER1,
			SKINCOLOR_ASUPER2,
			SKINCOLOR_ASUPER3,
			SKINCOLOR_ASUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_BSUPER1,
			SKINCOLOR_BSUPER2,
			SKINCOLOR_BSUPER3,
			SKINCOLOR_BSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_PSUPER1,
			SKINCOLOR_PSUPER2,
			SKINCOLOR_PSUPER3,
			SKINCOLOR_PSUPER4,
			SKINCOLOR_WSUPER5}
}

local podiumscale = {
	[1] = {1, 1},
	[2] = {3, 4},
	[3] = {1, 2}
}

local memescale = {
	[1] = {1, 1},	
	[2] = {31, 32},	
	[3] = {15, 16},
	[4] = {29, 32},
	[5] = {7, 8},
	[6] = {27, 32},
	[7] = {13, 16},
	[8] = {25, 32},
	[9] = {3, 4},
	[10] = {23, 32},
	[11] = {11, 16},
	[12] = {21, 32},
	[13] = {5, 8},
	[14] = {19, 32},
	[15] = {9, 16},
	[16] = {17, 32}
}

local function sp_SparkleMaker(mo)
	local r = (mo.radius/FRACUNIT)*4
	local z = (P_RandomKey((mo.height/FRACUNIT)*2)*FRACUNIT)
	local shiny = P_SpawnMobj(mo.x + (P_RandomRange(r, -r)*FRACUNIT), mo.y + (P_RandomRange(r, -r)*FRACUNIT), mo.z + z, MT_SPARKLETRAIL)
	shiny.target = mo
	shiny.color = mo.color
end

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end

	local p = mo.target.player
	
	if p.hqsuperfinish then
		if not mo.scycleset then
			mo.spodcycle = 1
			mo.scycleset = true
		end
		
		if leveltime%3 == 0 then
			if sp_participationtrophy.value then
				if p.kartstuff[k_position] < 4 then
					if mo.spodcycle >= #HQ_animSuper[p.kartstuff[k_position]] then
						mo.spodcycle = 1
					else
						mo.spodcycle = $ + 1
					end
				else
					if mo.spodcycle >= #HQ_animSuper[p.mo.hqsupernumber]
					and #HQ_animSuper[p.mo.hqsupernumber] then
						mo.spodcycle = 1
					else
						mo.spodcycle = $ + 1
					end
				end
			else
				if mo.spodcycle >= #superpodium[p.kartstuff[k_position]] then
					mo.spodcycle = 1
				else
					mo.spodcycle = $ + 1
				end
			end
		end
		if sp_participationtrophy.value then
			if p.kartstuff[k_position] < 4 then
				mo.color = superpodium[p.kartstuff[k_position]][mo.spodcycle]
			else
				mo.color = HQ_animSuper[p.mo.hqsupernumber][mo.spodcycle]
			end
		else
			mo.color = superpodium[p.kartstuff[k_position]][mo.spodcycle]
		end
	elseif p.mo.spinvfinish then
		if not mo.icycleset then
			mo.ipodcycle = 1
			mo.icycleset = true
		end

		if superpodium[4][mo.ipodcycle] ~= nil then --What the fuck.
			mo.color = superpodium[4][mo.ipodcycle]
		end
		
		sp_SparkleMaker(mo)
		sp_SparkleMaker(mo)
		sp_SparkleMaker(mo)

		if leveltime % 3 == 0 then
			if mo.ipodcycle >= #superpodium[4] then
				mo.ipodcycle = 1
			else
				mo.ipodcycle = $ + 1
			end
		end
	elseif p.mo.spgrowfinish then
		mo.color = SKINCOLOR_PERIWINKLE
	else
		if sp_participationtrophy.value then
			if p.kartstuff[k_position] <= 3 then
				mo.color = signpodium[p.kartstuff[k_position]]
			else
				if not mo.spcolorset
					mo.spstoredcolor = p.skincolor
					mo.spcolorset = true
				end

				mo.color = mo.spstoredcolor
			end
		else
			mo.color = signpodium[p.kartstuff[k_position]]
		end
	end

end, MT_SIGN)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
		
	if mo.target
	and mo.target.valid
	and mo.target.player then
		local p = mo.target.player
		
		if sp_participationtrophy.value then
			if p.kartstuff[k_position] <= #memescale then
				mo.scale = ((memescale[p.kartstuff[k_position]][1])*mapobjectscale)/(memescale[p.kartstuff[k_position]][2])
			else
				mo.scale = mapobjectscale/2
			end
		else
			mo.scale = ((podiumscale[p.kartstuff[k_position]][1])*mapobjectscale)/(podiumscale[p.kartstuff[k_position]][2])
		end
		
		if not mo.spscaleset then
			mo.spstoredscale = mo.scale
			mo.spscaleset = true
		end

		if p.mo.spgrowfinish then
			mo.scale = (mo.spstoredscale*3)/2
			if mo.eflags & MFE_JUSTHITFLOOR and not P_CheckDeathPitCollide(mo) then
				if abs(mo.spprevmomz) > mo.momz then
					if not mo.spquakesound
						S_StartSound(mo, sfx_s1cb)
						mo.spquakesound = true
					end
					if not mo.spquake then
						for x in players.iterate
							if not x.exiting then continue end
							if not splitscreen and x == displayplayers[0] then
								P_StartQuake(40<<FRACBITS, 6)
							end
						end
						mo.spquake = true
					end
				end
			end
			mo.spprevmomz = mo.momz
		else
			mo.scale = mo.spstoredscale
			-- You ever see a signpost change size after someone spec's?
			-- Shit is hilarious
		end
	end
end, MT_SIGN)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
		
	if mo.target.target
	and mo.target.target.valid
	and mo.target.target.player then
		if mo.spstoredscale ~= nil then
			mo.scale = mo.spstoredscale
		end
	end
end, MT_OVERLAY)

addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	
	for p in players.iterate
		if p.exiting then
			if p.kartstuff[k_growshrinktimer] > 0
			or (HugeQuest and p.hugequest.huge) then
				p.mo.spgrowfinish = true
			end
			
			if p.kartstuff[k_invincibilitytimer]
			and not p.hugequest.super then
				p.mo.spinvfinish = true
			end
			
			if sp_participationtrophy.value then
				if p.kartstuff[k_position] > 1 then
					if not p.mo.signspawned then
						local exitsign = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+(mapobjectscale*400),MT_SIGN)
						exitsign.target = p.mo
						exitsign.state = S_SIGN1
						exitsign.movefactor = p.mo.floorz
						exitsign.movecount = 1
						p.mo.signspawned = true
					end
				end
			else
				if p.kartstuff[k_position] == 2
				or p.kartstuff[k_position] == 3 then
					if not p.mo.signspawned then
						local exitsign = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+(mapobjectscale*400),MT_SIGN)
						exitsign.target = p.mo
						exitsign.state = S_SIGN1
						exitsign.movefactor = p.mo.floorz
						exitsign.movecount = 1
						p.mo.signspawned = true
					end
				end
			end
		end
	end
end)